<?php

namespace App\Notifications;

use App\EmailLog;
use Illuminate\Notifications\Notification;

class QueueEmailDatabaseChannel extends EmailDatabaseWriterChannelBase
{
    /**
     * Send the given notification.
     *
     * @param  mixed  $notifiable
     * @param  \Illuminate\Notifications\Notification  $notification
     * @return void
     */
    public function send($notifiable, Notification $notification)
    {
        /** @var EmailLog $logEntry */
        $logEntry = $notification->toEmailDatabase($notifiable);

        $this->writeToTable($logEntry, true);
    }
}